#!/usr/bin/perl

binmode STDIN, ":utf8";
binmode STDOUT, ":utf8";
use strict;

my $newstate = 1;
while(<STDIN>) {
    chomp;
    my @inputsym = ( split(//), '<w>' );
    my @outputsym = ( $_ );
    push @outputsym, '<eps>' while(@outputsym < @inputsym);
    my $currstate = 0;
    my $score = ' 1';
    while(@inputsym) {
        my $nextstate = (@inputsym == 1?0:$newstate++);
        print "$currstate $nextstate ".
            shift(@inputsym)." ".shift(@outputsym)."$score\n";
        $currstate = $nextstate;
        $score = '';
    }
}
print "0 0 <s> <s>\n";
print "0\n";
