#!/usr/bin/perl

binmode STDOUT, ":utf8";

# count the symbols to be printed
my %toprint;
while(@ARGV) {
    my $type = shift(@ARGV);
    die "Invalid option $type\n" if($type ne '-input' and $type ne '-output');
    my $idx = (($type eq '-input')?2:3);
    open FSTFILE, "<:utf8", shift(@ARGV) or die $!;
    while(<FSTFILE>) {
        chomp;
        my @arr = split(/[ \t]/);
        $toprint{$arr[$idx]}++ if(exists $arr[$idx]);
    }
}

my $curr = 0;
my @special = ('<eps>', '<s>', '<unk>', '<w>');
while($_ = shift(@special)) {
    print "$_ ".$curr++."\n";
    delete $toprint{$_};
}
for(sort keys %toprint) {
    print "$_ ".$curr++."\n";
}
